syms('F','OK','A','B','N','FLAG','NAME','OUP');
syms('M','FLAG0','C','X','s','D','XD','YD','ZD','NTOT');
syms('IP1','JP1','IP2','JP2','IP3','JP3','IP4','JP4');
syms('X1','YI','Z1','X2','Y2','Z2','X3','Y3','Z3','X4','Y4','Z4');
syms('D1','D2','D3','D4','N1','N2','N3','N4');
TRUE = 1;
FALSE = 0;
fprintf(1,'Formula de Interpolacion de lagrange en 2D\n');
OK = FALSE;
while OK == FALSE 
   fprintf(1,'Elija la forma de entrada de datos:\n');
   fprintf(1,'1.  Generar datos usando una funcion F\n');
   fprintf(1,'2. Entrada desde un fichero de texto\n');
   fprintf(1,'Escriba 1 o 2 \n');
   FLAG = input(' ');
   if FLAG == 1 | FLAG == 2 
      OK = TRUE;
   end
end
OK = FALSE;
while OK == FALSE
   fprintf(1,'Escriba la longitud de X y de Y en lineas separadas.\n');
   A = input(' ');
   B = input(' ');
   fprintf(1,'Escriba el numero de puntos en X y en Y en lineas separadas.\n');
   N = input(' ');
   M = input(' ');
   if A > 0 & B > 0 & N > 0 & M > 0
      X = zeros(N,M,3);
      OK = TRUE;
   end
end
C = A/(N-1);
D = B/(M-1);
if FLAG == 1 
   fprintf(1,'Escriba la funcion F(x,y) en terminos de x e y\n');
   fprintf(1,'Por ejemplo: y-x^2+1\n');
   s = input(' ','s');
   F = inline(char(s),'x','y');
   for J = 1 : M
      for I = 1 : N
         X(I,J,1) = (I-1)*C;
         X(I,J,2) = (J-1)*D;
         X(I,J,3) = F(X(I,J,1),X(I,J,2));
      end;
   end;
   fprintf(1,'Elija la forma de salida de datos:\n');
   fprintf(1,'1. Pantalla\n');
   fprintf(1,'2. Fichero de texto\n');
   fprintf(1,'Escriba 1 o 2\n');
   FLAG0 = input(' ');
   if FLAG0 == 2 
      fprintf(1,'Escriba el nombre del fichero de la forma - disco:\\nombre.ext\n');
      fprintf(1,'Por ejemplo   A:\\OUTPUT.DTA\n');
      NAME = input(' ','s');
      OUP = fopen(NAME,'wt');
   else
      OUP = 1;
   end;
   fprintf(OUP, '%11.5f %11.5f %11.5f %11.5f\n', A,B,N,M);
   for J = 1 : M
      for I = 1 : N
         fprintf(OUP, '%11.5f %11.5f %11.5f\n', X(I,J,1),X(I,J,2),X(I,J,3));
      end;
   end;
   if OUP ~= 1 
      fclose(OUP);
      fprintf(1,'Fichero de salida creado satisfactoriamente \n',NAME);
   end;
end;
if FLAG == 2 
   fprintf(1,'Esta creado un fichero de texto con los datos en TRES? columnas?\n');
   fprintf(1,'donde la primera fila...?? e\n');
   fprintf(1,'Escriba Y o N\n')
   E = input(' ','s');
   if E == 'Y' | E == 'y' 
      fprintf(1,'Escriba el nombre del fichero de la forma - ');
      fprintf(1,'disco:\\nombre.ext\n');
      fprintf(1,'Por ejemplo:   A:\\DATA.DTA\n');
      NAME = input(' ','s');
      INP = fopen(NAME,'rt');
      OK = FALSE;
      while OK == FALSE 
         for J = 1 : M
            for I = 1 : N 
               for K = 1 : 3
                  X(I,J,K) = fscanf(INP, '%f',1);
               end;
            end;
         end;
      end;
   end;
end;
fprintf(1,'Introduzca un nuevo numero de puntos para x y para y en lineas separadas\n');
NN = input(' ');
MM = input(' ');
if  NN > N & MM > M
   XX = zeros(NN,MM,3);
   XD = zeros(1,NN);
   YD = zeros(1,MM);
   ZD = zeros(NN,MM);
   OK = TRUE;
end
CC = A/(NN-1);
DD = B/(MM-1);
for J = 1 : MM
   for I = 1 : NN
      XX(I,J,1) = (I-1)*CC;
      XX(I,J,2) = (J-1)*DD;
      
      IP1 = fix(XX(I,J,1)/C)+1;
      JP1 = fix(XX(I,J,2)/D)+1;
      if I==NN
         IP1 = fix(XX(I,J,1)/C);
      end;
      if J==MM
         JP1 = fix(XX(I,J,2)/D);
      end;
      IP2 = IP1+1;
      JP2 = JP1;
      IP3 = IP1+1;
      JP3 = JP1+1;
      IP4 = IP1;
      JP4 = JP1+1;
      
      X1 = X(IP1,JP1,1);
      Y1 = X(IP1,JP1,2); 
      X2 = X(IP3,JP3,1);
      Y2 = X(IP3,JP3,2);
      Z1 = X(IP1,JP1,3); 
      Z2 = X(IP2,JP2,3);
      Z3 = X(IP3,JP3,3);
      Z4 = X(IP4,JP4,3);
      
      D1 = ((X2-X1)*(Y2-Y1));
      D2 = -D1;
      D3 = D1;
      D4 = D1;
      
      N1 = (((X2-XX(I,J,1))*(Y2-XX(I,J,2)))/D1);
      N2 = (((X1-XX(I,J,1))*(Y2-XX(I,J,2)))/D2);
      N3 = (((X1-XX(I,J,1))*(Y1-XX(I,J,2)))/D3);
      N4 = (((XX(I,J,1)-X2)*(Y1-XX(I,J,2)))/D4);
      
      XX(I,J,3) = (N1*Z1+N2*Z2+N3*Z3+N4*Z4);
      
      ZD(I,J)=XX(I,J,3);
   end;
end;
for I = 1 : NN
   XD(I)=(I-1)*CC;
end;
for J = 1 : MM
   YD(J)=(J-1)*DD;
end;
figure(1);
surf(XD,YD,ZD');
title('Interpolacion de Lagrange en 2D');
fprintf(1,'\n');





fprintf(1,'***PROGRAMA PARA LA DETERMINACION DE LA TRAYECTORIA DE DESCENSO POR GRAVEDAD DE UNA PARTICULA***\n');
fprintf(1,'\n');

% Vectores que almacenaran los puntos de la trayectoria.
vecPendX = [];
vecPendY = [];
vecPendZ = [];
finProceso = 0;

%Introduccion del punto inicial de la trayectoria.
fprintf(1,'Introduzca las coordenadas X e Y del punto inicial de la trayectoria en lineas separadas.\n');
X0 = input(' ');
Y0 = input(' ');

%Introduccion del radio y el numero de puntos.
fprintf(1,'Valor del paso. (El paso es la distancia en horizontal hasta el nuevo punto).\n');
fprintf(1,'Se recomienda un valor menor al menor de los siguientes valores:\n'); %En caso contrario pueden producirse errores.

CC
DD

fprintf(1,'Introduzca el valor del paso.\n');
r = input(' ');

fprintf(1,'Introduzca el numero de trayectorias posibles.\n');
np = input(' ');

while (~finProceso)
   %Obtencion del cuadrante para el punto inicial.
   nx = fix(X0/CC)+1;
   ny = fix(Y0/DD)+1;
   
   x2 = nx*CC;
   y2 = ny*DD;
   x1 = x2-CC;
   y1 = y2-DD;
   
   %Calculo de la ZO del punto inicial de la trayectoria.
   Denom=(x2-x1)*(y2-y1);
   Z0 = ((x2-X0)*(y2-Y0)/Denom)*ZD(nx-1+1,ny-1+1) - ((x1-X0)*(y2-Y0)/Denom)*ZD(nx+1,ny-1+1) + ...
      ((x1-X0)*(y1-Y0)/Denom)*ZD(nx+1,ny+1) + ((X0-x2)*(y1-Y0)/Denom)*ZD(nx-1+1,ny+1);
   
   % Obtenemos los incrementos del angulo.
   angulo=360/np;
   
   Vector = [];
   nuevoAng = 0;
   for I = 1 : np
      Vector   = [Vector nuevoAng];
      nuevoAng = nuevoAng + angulo;   
   end
   
   %Determinacion de las coordenadas x e y de los nuevos puntos.
   vecX = [];
   vecY = [];
   for ind = 1 : length(Vector)
      vecX(ind) = r*cos(Vector(ind)) + X0;
      vecY(ind) = r*sin(Vector(ind)) + Y0;   
   end
   
   %Obtencion de los cuadrantes donde se encuentran los nuevos puntos generados.
   vecZ = [];
   for ind = 1 : length(Vector)
      %Obtencion del cuadrante para los puntos.
      nx = fix(vecX(ind)/CC)+1;
      ny = fix(vecY(ind)/DD)+1;
     
      x2 = nx*CC;
      y2 = ny*DD;
      x1 = x2-CC;
      y1 = y2-DD;
      
      if x2 > A
         vecZ(ind) = ((ZD(nx,ny-1+1))+(ZD(nx,ny+1)))/2;
                  
      elseif y2 > B 
             vecZ(ind) = ((ZD(nx+1,ny))+(ZD(nx+1,ny)))/2; 
         
      elseif y1 < 0 
              vecZ(ind) = ((ZD(nx-1+1,ny+1))+(ZD(nx+1,ny+1)))/2; 
          
     else 
      Denom=(x2-x1)*(y2-y1);   
      vecZ(ind) = ((x2-vecX(ind))*(y2-vecY(ind))/Denom)*ZD(nx-1+1,ny-1+1) - ((x1-vecX(ind))*(y2-vecY(ind))/Denom)*ZD(nx+1,ny-1+1) + ...
         ((x1-vecX(ind))*(y1-vecY(ind))/Denom)*ZD(nx+1,ny+1) + ((vecX(ind)-x2)*(y1-vecY(ind))/Denom)*ZD(nx-1+1,ny+1);
      end
   end
   
   %Comparacion de las Z de los nuevos puntos con la Z0.
   [Y,I] = max(Z0-vecZ);
   
   %Seleccionar las coordenadas x e y para max(Z0-Z). 
   %Guardar las coordenadas de los puntos seleccionados en dos vectores para su posterior representacion grafica.
   vecPendX = [vecPendX X0];
   vecPendY = [vecPendY Y0];
   vecPendZ = [vecPendZ Z0];
   
   %Comparacion de las coordenadas del punto obtenido para seguir con posible nuevo paso.
   %1- El punto resultante es el mismo. 2- El punto esta fuera de la malla.
   
   Compr = 1;
   
   for ind = 1 : length(vecZ);
          Com(ind) = Z0 - vecZ(ind);        
   end
  
   Compr = any(Com);
   
   if (Compr == 0)
       finProceso = 1;  
      vecPendX = [vecPendX];
      vecPendY = [vecPendY];
      vecPendZ = [vecPendZ];    
           
   elseif ((vecX(I) >= A) | (vecX(I) <=0) | (vecY(I) >= B) | (vecY(I) <= 0))
      finProceso = 1;
      vecPendX = [vecPendX vecX(I)];
      vecPendY = [vecPendY vecY(I)];
      vecPendZ = [vecPendZ vecZ(I)];
   end
   
   % Redefinimos de nuevo el punto.
   X0 = vecX(I);
   Y0 = vecY(I);   
end

hold on;
plot3(vecPendX,vecPendY,vecPendZ,'-w','LineWidth',2);
title('TRAYECTORIA DE DESCENSO POR GRAVEDAD DE UNA PARTICULA'),xlabel('x'),ylabel('y'),zlabel('z');
hold off;
fprintf(1,'Fin del proceso.\n');